import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

@SuppressWarnings("unchecked")
public class Gp {
	static List		flist;
	static Fwrapper	addw;
	static Fwrapper	subw;
	static Fwrapper	mulw;
	static Fwrapper	ifw;
	static Fwrapper	gtw;
	
	public Gp() {
		addw = new Fwrapper(new AddW(), 2, "add");
		subw = new Fwrapper(new SubW(), 2, "subtract");
		mulw = new Fwrapper(new MulW(), 2, "multiply");
		ifw  = new Fwrapper(new IfFunc(), 3, "if");
		gtw  = new Fwrapper(new IsGreater(), 2, "isgreater");
		flist = new ArrayList();
		flist.add(addw);
		flist.add(mulw);
		flist.add(ifw);
		flist.add(gtw);
		flist.add(subw);
	}
	
	Node exampletree() {
		List gtwParList  = new ArrayList();
		gtwParList.add(new ParamNode(0));
		gtwParList.add(new ConstNode(3));
		
		List addwParList = new ArrayList();
		addwParList.add(new ParamNode(1));
		addwParList.add(new ConstNode(5));
		
		List subwParList = new ArrayList();
		subwParList.add(new ParamNode(1));
		subwParList.add(new ConstNode(2));
		
		List ifwParList  = new ArrayList();
		ifwParList.add(new Node(gtw, gtwParList));
		ifwParList.add(new Node(addw, addwParList));
		ifwParList.add(new Node(subw, subwParList));
		
		return (new Node(ifw, ifwParList));
	}

	Node makeRandamTree(int pc) {
		return (makeRandamTree(pc, 4, 0.5, 0.6));
	}
	
	Node makeRandamTree(int pc, int maxdepth, double fpr, double ppr) {
		if (Math.random() < fpr && maxdepth >0) {
			Fwrapper f = (Fwrapper)Randam.choid(flist);
			List children = new ArrayList<Node>();
			for (int i = 0; i < f.childCount; i++ ) {
				Node node = makeRandamTree(pc, maxdepth-1, fpr, ppr);
				children.add(node);
			}
			return (new Node(f, children));
		}
		else if (Math.random() < ppr) {
			return (new ParamNode(Randam.randint(0, pc-1)));
		}
		else
			return (new ConstNode(Randam.randint(0, 10)));
	}
	
	Double hiddenFunction(int x, int y) {
		double val = x*x + 2*y + 3*x + 5;
		return (new Double(val));
	}
	
	List buildHiddenSet() {
		List rows = new ArrayList();
		for (int i = 0; i < 200; i++) {
			int x = Randam.randint(0, 40);
			int y = Randam.randint(0, 40);
			List cols = new ArrayList();
			cols.add(new Double(x));
			cols.add(new Double(y));
			cols.add(hiddenFunction(x, y));
			rows.add(cols);
		}
		return (rows);
	}
	
	int scoreFunction(Node tree, List s) {
		double dif = 0;
		for (int i = 0; i < s.size(); i++) {
			List cols = (List)s.get(i);
			double v = Double.parseDouble(tree.evaluate(cols).toString());
			dif += Math.abs(v - ((Double)cols.get(2)).doubleValue());		
		}
		return ((int)dif);
	}
	
	Node mutate(Node t, int pc) {
		return (mutate(t, pc, 0.1));
	}
	
	Node mutate(Node t, int pc, double probchange) {
		if (Math.random() < probchange) {
			return (makeRandamTree(pc));
		}
		else {
			Node result = (Node)t.clone();
			if (t.children != null) {
				List children = new ArrayList();
				for (int i = 0; i < t.children.size(); i++) {
					Node c = t.children.get(i);
					children.add(mutate(c, pc, probchange));
				}
				result.children = children;
			}
			return (result);
		}
	}

	Node crossover(Node t1, Node t2) {
		return (crossover(t1, t2, 0.7, 1));
	}
	
	Node crossover(Node t1, Node t2, double probswap, int top) {
		if (Math.random() < probswap && top == 0) {
			return ((Node)t2.clone());
		}
		else {
			Node result = (Node)t1.clone();
			if (t1.children != null && t2.children != null) {
				List children = new ArrayList<Node>();
				for (int i = 0; i < t1.children.size(); i++) {
					Node c =  t1.children.get(i);
					children.add(crossover(c, (Node)Randam.choid(t2.children), probswap, 0));
				}
				result.children = children;
			}
			return (result);
		}
	}

	int selectindex(double pexp) {
		return ((int)((Math.log(Math.random()))/Math.log(pexp)));
	}

	void evolve(int pc, int popsize, IRankingFunction raunkingFunction, int maxgen, 
			double mutationRate, double breedingRate, double pexp, double pnew) {
		List population = new ArrayList();
		for (int i = 0; i < popsize; i++) {
			population.add(makeRandamTree(pc));
		}
		List scores = null;
		List first;
		for (int i = 0; i < maxgen; i++) {
			scores = raunkingFunction.ranking(population);			
			first = (List)scores.get(0);
			System.out.println(first.get(0).toString());
			int score = ((Double)first.get(0)).intValue();
			if (score == 0)
				break;
			
			// add top 2 nodes
			List newop = new ArrayList();
			newop.add(first.get(1));
			List second = (List)scores.get(1);
			newop.add(second.get(1));
			
			// generate nest genration.
			while (newop.size() < popsize) {
				if (Math.random() > pnew) {
					List l1 = (List)scores.get(selectindex(pexp));
					List l2 = (List)scores.get(selectindex(pexp));
					newop.add(mutate(
							crossover((Node)l1.get(1), (Node)l2.get(1), breedingRate, 1),
							pc, mutationRate));
				}
				else
					newop.add(makeRandamTree(pc));
			}
			population = newop;
		}
		first = (List)scores.get(0);
		Node best = (Node)first.get(1);
		best.display(0);
	}
	
	IRankingFunction getRankFunction(List dataSet) {		
		class RankingFunction implements IRankingFunction {
			List	dataSet;
			RankingFunction(List dataSet) {
				this.dataSet = dataSet;
			}
			public List ranking(List population) {
				List scores = new ArrayList();
				for (int i = 0; i < population.size(); i++) {
					Node t = (Node)population.get(i);
					List taple = new ArrayList();
					taple.add(new Double(scoreFunction(t, dataSet)));
					taple.add(t);
					scores.add(taple);
				}
				Collections.sort(scores, new ScoreComparator());
				return (scores);
			}			
		}
		
		return (new RankingFunction(dataSet));
	}
	
	/* test program */
	void test1() {
		Node 	exampleTree = exampletree();
		List	para1 = new ArrayList();
		para1.add(new Double(2));
		para1.add(new Double(3));
		System.out.println(exampleTree.evaluate(para1));	
		
		List	para2 = new ArrayList();
		para2.add(new Double(5));
		para2.add(new Double(3));
		System.out.println(exampleTree.evaluate(para2));			
	}
	
	void test2() {
		Node 	exampleTree = exampletree();
		exampleTree.display(0);
	}

	void test3() {
		Node 	random1 = makeRandamTree(2);
		System.out.println("random1");
		random1.display(0);
		System.out.println("evaluate");
		
		List	para1 = new ArrayList();
		para1.add(new Double(7));
		para1.add(new Double(1));
		System.out.println(random1.evaluate(para1));			
		List	para2 = new ArrayList();
		para2.add(new Double(2));
		para2.add(new Double(4));
		System.out.println(random1.evaluate(para2));	
		
		Node 	random2 = makeRandamTree(2);
		System.out.println("random2");
		random2.display(0);
		System.out.println("evaluate");
		
		List	para3 = new ArrayList();
		para3.add(new Double(5));
		para3.add(new Double(3));
		System.out.println(random2.evaluate(para3));			
		List	para4 = new ArrayList();
		para4.add(new Double(5));
		para4.add(new Double(20));
		System.out.println(random2.evaluate(para4));		
	}

	void test4() {
		List hiddenset = buildHiddenSet();
		Node 	random1 = makeRandamTree(2);
		System.out.println("random1");
		random1.display(0);
		System.out.println("score");
		System.out.println(scoreFunction(random1, hiddenset));
		Node 	random2 = makeRandamTree(2);
		System.out.println("random2");
		random2.display(0);
		System.out.println("score");
		System.out.println(scoreFunction(random2, hiddenset));
	}

	void test5() {
		List hiddenset = buildHiddenSet();
		Node 	random2 = makeRandamTree(2);
		System.out.println("random2");
		random2.display(0);
		System.out.println("random2 socre=" + scoreFunction(random2, hiddenset));
		System.out.println("mutate");
		Node	muttree = mutate(random2, 2);
		muttree.display(0);
		System.out.println("muttree socre=" + scoreFunction(muttree, hiddenset));
	}

	void test6() {
		List hiddenset = buildHiddenSet();
		Node 	randam1 = makeRandamTree(2);
		System.out.println("random1");
		randam1.display(0);

		Node 	randam2 = makeRandamTree(2);
		System.out.println("randam2");
		randam2.display(0);
		
		Node	cross = crossover(randam1, randam2);
		System.out.println("cross");
		cross.display(0);
	}

	void test7() {
		List hiddenset = buildHiddenSet();
		IRankingFunction rk = getRankFunction(hiddenset);
		evolve(2, 500, rk, 500, 0.2, 0.1, 0.7, 0.1);
	}

	public static void main(String[] args) {
		Gp		gp = new Gp();
		gp.test6();
	}
}

class ScoreComparator implements Comparator<List> {
	public int compare(List o1, List o2) {
		Double v1 = (Double)o1.get(0);
		Double v2 = (Double)o2.get(0);
		if (v1.equals(v2))
			return (0);
		else if (v1 < v2)
			return (-1);
		else
			return 1;
	}	
}

interface IRankingFunction {
	List	ranking(List population);
}

interface IFunction {
	Object eval(List l);
}

@SuppressWarnings("unchecked")
class Node {
	IFunction	function;
	String		name;
	List<Node>	children;
	
	Node() {
		this(null, null);
	}
	
	Node(Fwrapper fw, List children) {
		if (fw != null) {
			this.function = fw.function;
			this.name = fw.name;
		}
		this.children = children;		
	}
	
	protected Object evaluate(List inp) {
		List results = new ArrayList();
		for (int i = 0; i < children.size(); i++) {
			Node node = children.get(i);
			results.add(node.evaluate(inp));
		}
		return this.function.eval(results);
	}
	
	protected void display(int indent) {
		for (int i = 0; i < indent; i++)
			System.out.print(" ");
		System.out.println(name);
		for (int i = 0; i < children.size(); i++) {
			children.get(i).display(indent + 1);
		}
	}
	
	protected void deepCopy(Node dst, Node src) {
		dst.function = src.function;
		dst.name = src.name;
		if (src.children != null)
			dst.children = new ArrayList<Node>(src.children);		
	}
	
	public Object clone() {
		Node dst = new Node();
		dst.deepCopy(dst, this);
		return (dst);
	}
}

class Fwrapper extends Node {
	int	childCount;
	
	Fwrapper(IFunction function, int childCount, String name) {
		this.function = function;
		this.childCount = childCount;
		this.name = name;
	}
	
	public Object clone() {
		Fwrapper dst = new Fwrapper(function, childCount, name);
		dst.deepCopy(dst, this);
		return (dst);
	}

}

class ParamNode extends Node {
	int	idx;
	
	ParamNode(int idx) {
		this.idx = idx;
	}
	
	protected Object evaluate(List inp) {
		return (inp.get(idx));
	}	
	
	protected void display(int indent) {
		for (int i = 0; i < indent; i++)
			System.out.print(" ");
		System.out.format("p%d\n", idx);
	}

	public Object clone() {
		ParamNode dst = new ParamNode(idx);
		dst.deepCopy(dst, this);
		return (dst);
	}

}

class ConstNode extends Node {
	Double	v;
	
	ConstNode(double v) {
		this.v = v;
	}
	
	protected Object evaluate(List inp) {
		return (v);
	}	
	
	protected void display(int indent) {
		for (int i = 0; i < indent; i++)
			System.out.print(" ");
		System.out.format("%.1f\n", v);
	}
	
	public Object clone() {
		ConstNode dst = new ConstNode(v);
		dst.deepCopy(dst, this);
		return (dst);
	}

}

class AddW implements IFunction {
	public Object eval(List l) {
		return (Double)l.get(0) + (Double)l.get(1);
	}	
}

class SubW implements IFunction {
	public Object eval(List l) {
		return (Double)l.get(0) - (Double)l.get(1);
	}	
}

class MulW implements IFunction {
	public Object eval(List l) {
		return (Double)l.get(0) * (Double)l.get(1);
	}	
}

class IfFunc implements IFunction {
	public Object eval(List l) {
		if ((Double)l.get(0) > 0) 
			return l.get(1);
		else
			return l.get(2);
	}	
}

class IsGreater implements IFunction {
	public Object eval(List l) {
		if ((Double)l.get(0) > (Double)l.get(1)) 
			return new Double(1);
		else
			return new Double(0);
	}	
}
